<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>All Courses</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"> <!-- bootstrap css -->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css"> <!-- font awesome -->
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>    <!-- jquery -->
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script> <!-- bootstrap js -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/toastr.js/latest/toastr.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/toastr.js/latest/toastr.css"/>
    
    <!-- Import DataTable Library -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.12.1/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.12.1/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.12.1/js/dataTables.bootstrap4.min.js"></script>

<style>
.pointer {
    cursor: pointer;
}
</style>

</head>
<body>
    <div class="container">
        <div class="text-center my-4">
            <h2>DANH SÁCH KHÓA HỌC</h2>
        </div>
    </div> 
    <div class="row ml-2">
        <div class="col-sm-4 text-left mt-2 mb-4">
            <button class = "btn btn-success" id = "btn-add-course"><i class="fas fa-plus-circle"></i>&nbsp; Thêm khóa học</button>
        </div>
    </div>
    <div class="container-fluid ml-2">
      <table class="table table-bordered table-striped table-hover" id="course-table">
        <thead>
          <tr>
            <th>ID</th>
            <th>Course Code</th>
            <th>Course Name</th>
            <th>Price</th>
            <th>Discount Price</th>
            <th>Duration</th>
            <th>Level</th>
            <th>Cover Image</th>
            <th>Teacher Name</th>
            <th>Teacher Photo</th>
            <th>Popular</th>
            <th>Trending</th>
            <th>Action</th>
          </tr>
        </thead>
      </table>
      <tbody>

      </tbody>
    </div>

<!-- Vùng modal -->

<!-- Create course modal -->
<div>
    <div id="create-course-modal" class="modal fade" tabindex="-1">
      <div class="modal-dialog">
        <div class="modal-content">

          <!-- modal header -->
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">Thêm Khóa Học</h5>
            <button class="close" data-dismiss="modal">×</button>
          </div>
  
          <!-- modal body -->
          <div class="modal-body">
            <!-- form begins -->
            <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-create-course-code">Course Code</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-create-course-code" name="course-code" placeholder="" class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-create-course-name">Course Name</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-create-course-name" name="course-name" placeholder="" class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-create-price">Price</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-create-price" name="price" placeholder="" class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-create-discount-price">Discount Price</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-create-discount-price" name="discount-price" placeholder="" class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-create-duration">Duration</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-create-duration" name="duration" placeholder="" class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-create-level">Level</label>
                </div>
                <div class="col-sm-8">
                  <select class="form-control" name="select-create-level" id="select-create-level">
                    <option value="Beginner">Beginner</option>
                    <option value="Intermediate">Intermediate</option>
                    <option value="Advanced">Advanced</option>
                  </select>
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-create-cover-image">Cover Image</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-create-cover-image" name="cover-image" placeholder="" class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-create-teacher-name">Teacher Name</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-create-teacher-name" name="teacher-name" placeholder="" class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-create-teacher-photo">Teacher Photo</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-create-teacher-photo" name="teacher-photo" placeholder="" class="form-control">
                </div>
              </div>
              <div class="row">
                <div class="col-sm-4">
                    <label for = "select-popular">Popular</label>
                </div>
                <div class="col-sm-8">
                    <input type="radio" name="popular" value="true">True &nbsp;
                    <input type="radio" name="popular" value="false">False
                </div>
            </div>
            <div class="row">
                <div class="col-sm-4">
                    <label for = "select-trending">Trending</label>
                </div>
                <div class="col-sm-8">
                    <input type="radio" name="trending" value="true">True &nbsp;
                    <input type="radio" name="trending" value="false">False
                </div>
            </div>
            <!-- form ends -->
          </div>
          <!-- modal footer -->
          <div class="modal-footer">
            <button class="btn btn-success" id="btn-create-course" >Thêm</button>
            <button class="btn btn-warning" id="btn-cancel-course" data-dismiss="modal">Hủy Bỏ</button>
          </div>
        </div>
      </div>
    </div>
  </div>
  <!-- Ends Create course modal -->

  <!-- Edit course modal -->
<div>
    <div id="edit-course-modal" class="modal fade" tabindex="-1">
      <div class="modal-dialog">
        <div class="modal-content">

          <!-- modal header -->
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">Sửa Khóa Học</h5>
            <button class="close" data-dismiss="modal">×</button>
          </div>
  
          <!-- modal body -->
          <div class="modal-body">
            <!-- form begins -->
            <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-edit-course-code">Course Code</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-edit-course-code" name="course-code" placeholder="" class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-edit-course-name">Course Name</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-edit-course-name" name="course-name" placeholder="" class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-edit-price">Price</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-edit-price" name="price" placeholder="" class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-edit-discount-price">Discount Price</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-edit-discount-price" name="discount-price" placeholder="" class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-edit-duration">Duration</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-edit-duration" name="duration" placeholder="" class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-edit-level">Level</label>
                </div>
                <div class="col-sm-8">
                  <select class="form-control" name="select-edit-level" id="select-edit-level">
                    <option value="Beginner">Beginner</option>
                    <option value="Intermediate">Intermediate</option>
                    <option value="Advanced">Advanced</option>
                  </select>
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-edit-cover-image">Cover Image</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-edit-cover-image" name="cover-image" placeholder="" class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-edit-teacher-name">Teacher Name</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-edit-teacher-name" name="teacher-name" placeholder="" class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-edit-teacher-photo">Teacher Photo</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-edit-teacher-photo" name="teacher-photo" placeholder="" class="form-control">
                </div>
              </div>
              <div class="row">
                <div class="col-sm-4">
                    <label for = "select-popular">Popular</label>
                </div>
                <div class="col-sm-8">
                    <input type="radio" name="popular" value="true">True &nbsp;
                    <input type="radio" name="popular" value="false">False
                </div>
            </div>
            <div class="row">
                <div class="col-sm-4">
                    <label for = "select-trending">Trending</label>
                </div>
                <div class="col-sm-8">
                    <input type="radio" name="trending" value="true">True &nbsp;
                    <input type="radio" name="trending" value="false">False
                </div>
            </div>
            <!-- form ends -->
          </div>
          <!-- modal footer -->
          <div class="modal-footer">
            <button class="btn btn-success" id="btn-edit-course">Sửa</button>
            <button class="btn btn-warning" id="btn-cancel-course" data-dismiss="modal">Hủy Bỏ</button>
          </div>
        </div>
      </div>
    </div>
  </div>

<!-- Delete confirm modal -->
<div>
    <div class="modal fade" tabindex="-1" id="delete-course-modal">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">Xác nhận xóa khóa học</h5>
            <button class="close" data-dismiss="modal">×</button>
          </div>
          <div class="modal-body">
            <label>Bạn có chắc chắn muốn xóa khóa học này không?</label>
          </div>
          <div class="modal-footer">
            <button class="btn btn-danger" id="btn-confirm-delete-course">Confirm</button>
            <button class="btn btn-warning" data-dismiss="modal">Hủy Bỏ</button>
          </div>
        </div>
      </div>
    </div>
  </div>


</body>
<script>
    "use strict";
    $(document).ready(function (){
        onPageLoading();
    });

/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
// var gCoursesDB = {
//     description: "This DB includes all courses in system",
//     courses: [
//         {
//             id: 1,
//             courseCode: "FE_WEB_ANGULAR_101",
//             courseName: "How to easily create a website with Angular",
//             price: 750,
//             discountPrice: 600,
//             duration: "3h 56m",
//             level: "Beginner",
//             coverImage: "images/courses/course-angular.jpg",
//             teacherName: "Morris Mccoy",
//             teacherPhoto: "images/teacher/morris_mccoy.jpg",
//             isPopular: false,
//             isTrending: true
//         },
//         {
//             id: 2,
//             courseCode: "BE_WEB_PYTHON_301",
//             courseName: "The Python Course: build web application",
//             price: 1050,
//             discountPrice: 900,
//             duration: "4h 30m",
//             level: "Advanced",
//             coverImage: "images/courses/course-python.jpg",
//             teacherName: "Claire Robertson",
//             teacherPhoto: "images/teacher/claire_robertson.jpg",
//             isPopular: false,
//             isTrending: true
//         },
//         {
//             id: 5,
//             courseCode: "FE_WEB_GRAPHQL_104",
//             courseName: "GraphQL: introduction to graphQL for beginners",
//             price: 850,
//             discountPrice: 650,
//             duration: "2h 15m",
//             level: "Intermediate",
//             coverImage: "images/courses/course-graphql.jpg",
//             teacherName: "Ted Hawkins",
//             teacherPhoto: "images/teacher/ted_hawkins.jpg",
//             isPopular: true,
//             isTrending: false
//         },
//         {
//             id: 6,
//             courseCode: "FE_WEB_JS_210",
//             courseName: "Getting Started with JavaScript",
//             price: 550,
//             discountPrice: 300,
//             duration: "3h 34m",
//             level: "Beginner",
//             coverImage: "images/courses/course-javascript.jpg",
//             teacherName: "Ted Hawkins",
//             teacherPhoto: "images/teacher/ted_hawkins.jpg",
//             isPopular: true,
//             isTrending: true
//         },
//         {
//             id: 8,
//             courseCode: "FE_WEB_CSS_111",
//             courseName: "CSS: ultimate CSS course from beginner to advanced",
//             price: 750,
//             discountPrice: 600,
//             duration: "3h 56m",
//             level: "Beginner",
//             coverImage: "images/courses/course-css.jpg",
//             teacherName: "Juanita Bell",
//             teacherPhoto: "images/teacher/juanita_bell.jpg",
//             isPopular: true,
//             isTrending: true
//         },
//         {
//             id: 14,
//             courseCode: "FE_WEB_WORDPRESS_111",
//             courseName: "Complete Wordpress themes & plugins",
//             price: 1050,
//             discountPrice: 900,
//             duration: "4h 30m",
//             level: "Advanced",
//             coverImage: "images/courses/course-wordpress.jpg",
//             teacherName: "Clevaio Simon",
//             teacherPhoto: "images/teacher/clevaio_simon.jpg",
//             isPopular: true,
//             isTrending: false
//         }
//     ]
// };
// console.log (gCoursesDB.courses);

//Biến toàn cục chứa dữ liệu trong bảng
var gCoursesDB = [];

// Biến toàn cục để lưu trữ course id đang được edit hoặc delete
var gCourseId = 0;

//Biến toàn cục chứa giá trị của courseCode
var gCourseCode = "";

// Khai báo các biến hằng số của data table
var gSTT = 1;

var gName_Col = ["id", "courseCode", "courseName", "price", "discountPrice", "duration", "level", "coverImage", 
                "teacherName", "teacherPhoto", "isPopular", "isTrending", "action"];
const gID_COL = 0;
const gCOURSE_CODE_COL = 1;
const gCOURSE_NAME_COL = 2;
const gPRICE_COL = 3;
const gDISCOUNT_PRICE_COL = 4;
const gDURATION_COL = 5;
const gLEVEL_COL = 6;
const gCOVER_IMAGE_COL = 7;
const gTEACHER_NAME_COL = 8;
const gTEACHER_PHOTO_COL = 9;
const gIS_POPULAR_COL = 10;
const gIS_TRENDING_COL = 11;
const gACTION_COL = 12;

var gCOURSE_DATA_TABLE = $("#course-table").DataTable({
    columns: [
        { data: gName_Col[gID_COL] },
        { data: gName_Col[gCOURSE_CODE_COL] },
        { data: gName_Col[gCOURSE_NAME_COL] },
        { data: gName_Col[gPRICE_COL] },
        { data: gName_Col[gDISCOUNT_PRICE_COL] },
        { data: gName_Col[gDURATION_COL] },
        { data: gName_Col[gLEVEL_COL] },
        { data: gName_Col[gCOVER_IMAGE_COL] },
        { data: gName_Col[gTEACHER_NAME_COL] },
        { data: gName_Col[gTEACHER_PHOTO_COL] },
        { data: gName_Col[gIS_POPULAR_COL] },
        { data: gName_Col[gIS_TRENDING_COL] },
        { data: gName_Col[gACTION_COL] }
    ],
    columnDefs: [
        {
          targets: gID_COL,
          className: "text-center",
          render: function() {
            return gSTT++;
          }
        },
        {
            targets: gACTION_COL,
            className: "text-center",
            defaultContent: 
            `
            <button class="btn btn-info edit-course w-75" data-toggle="tooltip" data-placement="bottom" title="Sửa khóa học"><i class="fas fa-edit"></i></button>
            <button class="btn btn-danger mt-1 delete-course w-75" data-toggle="tooltip" data-placement="bottom" title="Xóa khóa học"><i class="fas fa-trash-alt"></i></button>
            `
        },
        {
            targets: gCOVER_IMAGE_COL,
            className: "text-center",
            render: function(paramCoverImage) {
              return ` <img src= ` + paramCoverImage + ` + style="width:150px"> `;                
            }
        },
        {
            targets: gTEACHER_PHOTO_COL,
            className: "text-center",
            render: function (paramTeacherPhoto) {
                return ` <img src= ` + paramTeacherPhoto + ` + style="width:100px"> `;                
            }
        }
    ]
});



/*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
// // Gán sự kiện cho nút Quay lại
// $("#btn-return-home-page").on("click", function () {
//     onBtnReturnHomePage();
// });

// Gán sự kiện cho nút thêm mới
$("#btn-add-course").on("click", function () {
    onBtnAddCourseClick();
});

// Gán sự kiện cho nút thêm (trong modal)
$("#btn-create-course").on("click", function () {
    onBtnTaoKhoaHocClick();
});

// Gán sự kiện cho icon sửa 
$("#course-table").on("click", ".edit-course", function () {
    onBtnEditCourseClick(this);
});

// Gán sự kiện cho nút sửa (trong modal)
$("#btn-edit-course").on("click", function () {
    onBtnSuaKhoaHocClick();
});


// Gán sự kiện cho icon xóa
$("#course-table").on("click", ".delete-course", function () {
    onBtnDeleteCourseClick(this);
});


// Gán sự kiện cho nút confirm
$("#btn-confirm-delete-course").on("click", function () {
    onBtnXoaKhoaHocClick();
});




/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */  
// Hàm xử lý sự kiện hàm onload
function onPageLoading() {
    //Call API get all courses
    requestToApiGetAllCourses();
};


// Hàm xử lý sự kiện cho nút thêm mới 
function onBtnAddCourseClick() {
    console.log("Nút thêm khóa học được click");
    $("#create-course-modal").modal("show");
    $("#create-course-modal").on("shown.bs.modal", function () {
        $("#input-create-course-code").trigger("focus");
    });
};



// Hàm xử lý sự kiện cho icon sửa 
function onBtnEditCourseClick(paramEditButton) {
    console.log("Nút sửa khóa học được click");
    // Lấy course id để gán vào biến global
    var vEditRowId = getEditCourseId(paramEditButton);
    // Hiển thị thông tin course tương ứng vào modal khi ấn nút sửa
    displayEditCourseToModal(gCourseId);
    console.log(gCoursesDB)

    // Hiển thị modal ra web
    $("#edit-course-modal").modal("show");
    $("#edit-course-modal").on("shown.bs.modal", function () {
        $("#input-edit-course-name").trigger("focus");
    });
};


// Hàm xử lý sự kiện cho icon xóa
function onBtnDeleteCourseClick(paramDeleteButton) {
    console.log("Nút xóa khóa học được click");
    // Lấy course id để gán vào biến global
    var vDeleteRowId = getDeleteCourseId(paramDeleteButton);
    // Hiển thị modal ra web
    $("#delete-course-modal").modal("show");
};

// Hàm xử lý sự kiện cho nút thêm (trong modal)
function onBtnTaoKhoaHocClick() {
    console.log("%c Nút thêm được click", "color:violet");
    //B0: Khai báo đối tượng chứa dữ liệu
    var vInputCreateCourseModal = {
          courseCode: "",
          courseName: "",
          price: -1,
          discountPrice: -1,
          duration: "",
          level: "",
          coverImage: "",
          teacherName: "",
          teacherPhoto: "",
          isPopular: "",
          isTrending: ""
      };
    //B1: Thu thập dữ liệu
    getInputCreateCourse(vInputCreateCourseModal);
    console.log(vInputCreateCourseModal);
    
    //B2: Validate input data
    var vCheckCode = validateInputCreateCourse(vInputCreateCourseModal);
    if (vCheckCode) {
        // console.log(vCheckCode);
        //B3: Gọi API tạo mới course
        requesToApiCreateNewCourse(vCheckCode);
        insertCourse(vInputCreateCourseModal);
        //B4: Hiển thị ra web
        // alert("Thêm khóa học thành công!");
        loadDataToTable(gCoursesDB);
        // window.location.href = "allCourses.html";
        resetCreateModalForm();
        $("#create-course-modal").modal("hide");
    };
};


// Hàm xử lý sự kiện cho nút sửa (trong modal)
function onBtnSuaKhoaHocClick() {
    console.log ("Nút sửa được click");
    //B0: Khai báo đối tượng chứa dữ liệu
    var vInputEditCourseModal = {
        _id: "",
        courseCode: "",
        courseName: "",
        price: -1,
        discountPrice: -1,
        duration: "",
        level: "",
        coverImage: "",
        teacherName: "",
        teacherPhoto: "",
        isPopular: "",
        isTrending: ""
    };
    //B1: Thu thập dữ liệu
    getInputEditCourse(vInputEditCourseModal);
    //B2: Validate input data
    var vLegalInputEditCourse = validateInputEditCourse(vInputEditCourseModal);
    if (vLegalInputEditCourse) {
        console.log(vLegalInputEditCourse);
        //B3: Gọi API sửa course
        requesToApiUpdateCourse(vLegalInputEditCourse);
        editCourse(vInputEditCourseModal);
        //B4: Hiển thị ra web
        // alert("Sửa thành công khóa học. Course ID: " + gCourseId);
        loadDataToTable(gCoursesDB);
        resetEditModalForm();
        $("#edit-course-modal").modal("hide");
    };
};


// Hàm xử lý sự kiện cho nút confirm xóa (trong modal)
function onBtnXoaKhoaHocClick() {
    console.log("Nút confirm xóa khóa học được click");
    //B3: Gọi API xóa khóa học
    requesToApiDeleteCourse();
    deleteCourse(gCourseId);
    //B4: Hiển thị ra web
    // alert("Đã xóa thành công Course ID: " + gCourseId);
    loadDataToTable(gCoursesDB);
    resetEditModalForm();
    $("#delete-course-modal").modal("hide");
};






/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
// // Khai báo hàm Return home page
// function onBtnReturnHomePage() {
//     console.log("Nút return được click");
//     window.location.href = "index.html";
// }
//Hàm hiện thông báo
let dispalyToastr = (paramStatus,paramMessage) =>{
            Command: toastr[`${paramStatus}`](`${paramMessage}`)

            toastr.options = {
            "closeButton": false,
            "debug": false,
            "newestOnTop": false,
            "progressBar": false,
            "positionClass": "toast-top-right",
            "preventDuplicates": false,
            "onclick": null,
            "showDuration": "300",
            "hideDuration": "1000",
            "timeOut": "5000",
            "extendedTimeOut": "1000",
            "showEasing": "swing",
            "hideEasing": "linear",
            "showMethod": "fadeIn",
            "hideMethod": "fadeOut"
            }
        }

//Khai báo hàm gọi API get all courses
function requestToApiGetAllCourses() {
    $.ajax({
      type: "GET",
      url: "/courses",
      dataType: "json",
      //async: false
          success: function (responseObj) {
            console.log(responseObj);
            //lưu vào biến toàn cục
            dispalyToastr("success","Get All Course successfully!");
            gCoursesDB = responseObj.courses;
            loadDataToTable(gCoursesDB);
          },
          error: function (ajaxContent) {
            dispalyToastr("warning",ajaxContent.responseText);
          }
  });
};

// Khai báo hàm load data to table
function loadDataToTable(paramUserArr) {
    gSTT = 1;
    gCOURSE_DATA_TABLE.clear();
    gCOURSE_DATA_TABLE.rows.add(paramUserArr);
    gCOURSE_DATA_TABLE.draw();
};


// Khai báo hàm reset create modal
function resetCreateModalForm() {
    $("#input-create-course-code").val("");
    $("#input-create-course-name").val("");

    $("#input-create-price").val("");
    $("#input-create-discount-price").val("");

    $("#input-create-duration").val("");
    $("#input-create-level").val("");

    $("#input-create-cover-image").val("");
    $("#input-create-teacher-name").val("");

    $("#input-create-teacher-photo").val("");
    $('input[name="popular"]:checked').val("");
    $('input[name="trending"]:checked').val("");
};

// Khai báo hàm reset edit modal
function resetEditModalForm() {
    $("#input-edit-course-name").val("");
    $("#input-edit-price").val("");

    $("#input-edit-discount-price").val("");
    $("#input-edit-duration").val("");
    $("#input-edit-level").val("");

    $("#input-edit-cover-image").val("");
    $("#input-edit-teacher-name").val("");

    $("#input-edit-teacher-photo").val("");
    $('input[name="popular"]:checked').val("");
    $('input[name="trending"]:checked').val("");
};


// Nút thêm mới
// Nút thêm mới khóa học (trong modal)
function getInputCreateCourse(paramInputCreateCourseModal) {
    // paramInputCreateCourseModal.id = getNextId(); // hàm tự tạo ra id mới tăng dần thêm 1
    paramInputCreateCourseModal.courseCode = $("#input-create-course-code").val().trim();
    paramInputCreateCourseModal.courseName = $("#input-create-course-name").val().trim();

    paramInputCreateCourseModal.price = parseInt($("#input-create-price").val());
    paramInputCreateCourseModal.discountPrice = parseInt($("#input-create-discount-price").val());

    paramInputCreateCourseModal.duration = $("#input-create-duration").val().trim();
    paramInputCreateCourseModal.level = $("#select-create-level").val();

    paramInputCreateCourseModal.coverImage = $("#input-create-cover-image").val().trim();
    paramInputCreateCourseModal.teacherName = $("#input-create-teacher-name").val().trim();

    paramInputCreateCourseModal.teacherPhoto = $("#input-create-teacher-photo").val().trim();
    paramInputCreateCourseModal.isPopular = $('input[name="popular"]:checked').val();
    paramInputCreateCourseModal.isTrending = $('input[name="trending"]:checked').val();
    
};
// Validate input data cho nút thêm mới (modal)
function validateInputCreateCourse(paramInputCreateCourseModal) {
    //*** Có thể để trống discountPrice, price > 0, discountPrice >= 0
    if (paramInputCreateCourseModal.courseCode == "") {
        alert("Bạn chưa điền course code");
        $("#input-create-course-code").focus();
        return false;
    }
    if (paramInputCreateCourseModal.courseName == "") {
        alert("Bạn chưa điền course name");
        $("#input-create-course-name").focus();
        return false;
    }
    if (paramInputCreateCourseModal.price == "") {
        alert("Bạn chưa điền price");
        $("#input-create-price").focus();
        return false;
    }
    if (isNaN(paramInputCreateCourseModal.price)) {
        alert("Price phải là số");
        $("#input-create-price").focus();
        return false;
    }
    if (paramInputCreateCourseModal.price <= 0) {
        alert("Price phải là số lớn hơn không");
        $("#input-create-price").focus();
        return false;
    }
    if (paramInputCreateCourseModal.discountPrice == "") {
        alert("Bạn chưa điền discount price");
        $("#input-create-discount-price").focus();
        return false;
    }
    if (isNaN(paramInputCreateCourseModal.discountPrice)) {
        alert("Discount Price phải là số");
        $("#input-create-discount-price").focus();
        return false;
    }
    if (paramInputCreateCourseModal.discountPrice < 0) {
        alert("Discount Price phải là số lớn hơn hoặc bằng 0");
        $("#input-create-discount-price").focus();
        return false;
    }
    if (paramInputCreateCourseModal.duration == "") {
        alert("Bạn chưa điền duration");
        $("#input-create-duration").focus();
        return false;
    }
    if (paramInputCreateCourseModal.level == "") {
        alert("Bạn chưa điền level");
        $("#input-create-level").focus();
        return false;
    }
    if (paramInputCreateCourseModal.coverImage == "") {
        alert("Bạn chưa điền đường dẫn để lấy cover image");
        $("#input-create-cover-image").focus();
        return false;
    }
    if (paramInputCreateCourseModal.teacherName == "") {
        alert("Bạn chưa điền teacher name");
        $("#input-create-teacher-name").focus();
        return false;
    }
    if (paramInputCreateCourseModal.teacherPhoto == "") {
        alert("Bạn chưa điền đường dẫn để lấy teacher photo");
        $("#input-create-teacher-photo").focus();
        return false;
    }
    if (paramInputCreateCourseModal.isPopular == null) {
        alert("Bạn phải chọn true hoặc false");
        return false;
    }
    if (paramInputCreateCourseModal.isTrending == null) {
        alert("Bạn phải chọn true hoặc false");
        return false;
    }
    return true;
};

// Gọi API tạo mới course
function requesToApiCreateNewCourse(paramLegalInputCreateCourse) {
  $.ajax({
        type: "POST",
        url: "/courses",
        data: JSON.stringify(paramLegalInputCreateCourse),
        contentType: "application/json",
        dataType: "json",
        success: function (responseObject) {
          dispalyToastr("success","Create course successfully!");
            console.log(responseObject);
        },
        error: function (ajaxContent) {
          dispalyToastr("warning",ajaxContent.responseText);
            // console.log(ajaxContent.responseText);
        }
    });
};

// Khai báo hàm insert courses vào đối tượng chứa dữ liệu
function insertCourse(paramInputCreateCourseModal) {
    gCoursesDB.push(paramInputCreateCourseModal);
};
// hàm sinh ra đc id tự tăng tiếp theo, dùng khi thêm mới phần tử
// function getNextId() {
//     var vNextId = 0;
//     // Nếu mảng chưa có đối tượng nào thì Id = 1
//     if(gCoursesDB.length == 0) {
//       vNextId = 1;
//     }
//   // Id tiếp theo bằng Id của phần tử cuối cùng + thêm 1    
// else {
//       vNextId = gCoursesDB[gCoursesDB.length - 1].id + 1;
//     }
//     return vNextId;
// };


// Nút sửa
// Khai báo hàm lấy course id để gắn vào biến global
function getEditCourseId(paramEditButton) {
    var vTableRow = $(paramEditButton).parents("tr");
    var vEditRowData = gCOURSE_DATA_TABLE.row(vTableRow).data();

    gCourseCode = vEditRowData.courseCode; // Gán giá trị vào biến toàn cục
    console.log("%c Edit Course Code: " + gCourseCode, "color:red");

    //lọc tìm id tương ứng nếu trùng courseCode
    gCoursesDB.filter(data => {
        if (data.courseCode.toUpperCase() === gCourseCode.toUpperCase()) {
          gCourseId = data._id;
            console.log(`Edit Course ID: ${gCourseId}`);
            return gCourseId;
        };
    });
};


//**** Nút sửa
// Khai báo hàm hiển thị thông tin ra modal khi ấn nút sửa
function displayEditCourseToModal(paramCourseId) {
    var vCourseIndex = getIndexFromCourseId(paramCourseId);
    $("#input-edit-course-code").val(gCoursesDB[vCourseIndex].courseCode); 
    $("#input-edit-course-name").val(gCoursesDB[vCourseIndex].courseName); 
    $("#input-edit-price").val(gCoursesDB[vCourseIndex].price);
    $("#input-edit-discount-price").val(gCoursesDB[vCourseIndex].discountPrice);

    $("#input-edit-duration").val(gCoursesDB[vCourseIndex].duration);
    $("#select-edit-level").val(gCoursesDB[vCourseIndex].level);

    $("#input-edit-cover-image").val(gCoursesDB[vCourseIndex].coverImage);
    $("#input-edit-teacher-name").val(gCoursesDB[vCourseIndex].teacherName);
    $("#input-edit-teacher-photo").val(gCoursesDB[vCourseIndex].teacherPhoto);
    
    if (gCoursesDB[vCourseIndex].isPopular) {
      // console.log("isPopular boolean: " + gCoursesDB.isPopular);
      $('input[name="popular"]:checked').prop("checked", true);
    } else {
      $('input[name="popular"]:checked').prop("checked", false);
    }

    if (gCoursesDB[vCourseIndex].isTrending) {
      // console.log("isTrending boolean: " + gCoursesDB.isTrending);
      $('input[name="trending"]:checked').prop("checked", true);
    } else {
      $('input[name="trending"]:checked').prop("checked", false);
    }

    // $('input[name="popular"]:checked').prop("checked", gCoursesDB.courses[vCourseIndex].isPopular);
    // $('input[name="trending"]:checked').prop("checked", gCoursesDB.courses[vCourseIndex].isTrending);

    // var vPopularCourse = document.getElementsByName('popular');
    // for (var i = 0; i < vPopularCourse.length; i++) {
    //     if (vPopularCourse[i].checked) {
    //         // do whatever you want with the checked radio
    //         console.log(vPopularCourse[i].value);

    //         // only one radio can be logically checked, don't check the rest
            
    //     }
    // }


    // if (gCoursesDB.courses[vCourseIndex].isPopular.text() = "true") {
    //     $('input[name="popular"]:checked').val("true")
    // }

    // if (gCoursesDB.courses[vCourseIndex].isPopular.text() = "false") {
    //     $('input[name="popular"]:checked').val("false")
    // }
    

    // $('#checkbox-value').text($('#checkbox1').val());
    // $("#checkbox1").on('change', function() {
    // if ($(this).is(':checked')) {
    //     $(this).attr('value', 'true');
    // } else {
    //     $(this).attr('value', 'false');
    // }
    
    // $('#checkbox-value').text($('#checkbox1').val());
    // });


    // <input type="checkbox" name="acceptRules" class="inline checkbox" id="checkbox1" value="false">
    // <div id="checkbox-value"></div>

    // gCoursesDB.courses[vCourseIndex].isPopular = $('input[name="popular"]:checked').val(); // gCoursesDB.courses[vCourseIndex].isPopular returns true / false
};

// Khai báo hàm thu thập dữ liệu cho nút sửa (trong modal)
function getInputEditCourse(paramInputEditCourseModal) {
    paramInputEditCourseModal._id = gCourseId;
    paramInputEditCourseModal.courseCode = $("#input-edit-course-code").val().trim();

    paramInputEditCourseModal.courseName = $("#input-edit-course-name").val().trim();
    paramInputEditCourseModal.price = $("#input-edit-price").val().trim();
    paramInputEditCourseModal.discountPrice = $("#input-edit-discount-price").val().trim();

    paramInputEditCourseModal.duration = $("#input-edit-duration").val().trim();
    paramInputEditCourseModal.level = $("#select-edit-level").val();

    paramInputEditCourseModal.coverImage = $("#input-edit-cover-image").val().trim();
    paramInputEditCourseModal.teacherName = $("#input-edit-teacher-name").val().trim();

    paramInputEditCourseModal.teacherPhoto = $("#input-edit-teacher-photo").val().trim();
    paramInputEditCourseModal.isPopular = $('input[name="popular"]:checked').val();
    paramInputEditCourseModal.isTrending = $('input[name="trending"]:checked').val();
    console.log("%c Nút sửa modal Course ID: " + paramInputEditCourseModal._id, "color:aqua");
};
// Validate dữ liệu cho nút sửa (trong modal)
function validateInputEditCourse(paramInputEditCourseModal) {
    if (paramInputEditCourseModal.courseName == "") {
        alert("Bạn chưa điền course name");
        $("#input-create-course-name").focus();
        return false;
    }
    if (paramInputEditCourseModal.price == "") {
        alert("Bạn chưa điền price");
        $("#input-create-price").focus();
        return false;
    }
    if (isNaN(paramInputEditCourseModal.price)) {
        alert("Price phải là số");
        $("#input-create-price").focus();
        return false;
    }
    if (paramInputEditCourseModal.price <= 0) {
        alert("Price phải là số lớn hơn không");
        $("#input-create-price").focus();
        return false;
    }
    if (paramInputEditCourseModal.discountPrice == "") {
        alert("Bạn chưa điền discount price");
        $("#input-create-discount-price").focus();
        return false;
    }
    if (isNaN(paramInputEditCourseModal.discountPrice)) {
        alert("Discount Price phải là số");
        $("#input-create-discount-price").focus();
        return false;
    }
    if (paramInputEditCourseModal.discountPrice < 0) {
        alert("Discount Price phải là số lớn hơn hoặc bằng 0");
        $("#input-create-discount-price").focus();
        return false;
    }
    if (paramInputEditCourseModal.duration == "") {
        alert("Bạn chưa điền duration");
        $("#input-create-duration").focus();
        return false;
    }
    if (paramInputEditCourseModal.level == "") {
        alert("Bạn chưa điền level");
        $("#input-create-level").focus();
        return false;
    }
    if (paramInputEditCourseModal.coverImage == "") {
        alert("Bạn chưa điền đường dẫn để lấy cover image");
        $("#input-create-cover-image").focus();
        return false;
    }
    if (paramInputEditCourseModal.teacherName == "") {
        alert("Bạn chưa điền teacher name");
        $("#input-create-teacher-name").focus();
        return false;
    }
    if (paramInputEditCourseModal.teacherPhoto == "") {
        alert("Bạn chưa điền đường dẫn để lấy teacher photo");
        $("#input-create-teacher-photo").focus();
        return false;
    }
    if (paramInputEditCourseModal.isPopular == null) {
        alert("Bạn phải chọn true hoặc false");
        return false;
    }
    if (paramInputEditCourseModal.isTrending == null) {
        alert("Bạn phải chọn true hoặc false");
        return false;
    }
    return true;
};

//Khai báo hàm gọi API sửa course
function requesToApiUpdateCourse(paramLegalInputEditCourse) {
  $.ajax({
        type: "PUT",
        // async: false,
        url: "/courses/" + gCourseId,
        dataType: "json",
        data: JSON.stringify(paramLegalInputEditCourse),
        contentType: "application/json; charset=utf-8",
        success: function (responseObj) {
          dispalyToastr("success","Update course successfully!");
            console.log(responseObj);
            // location.reload();
        },
        error: function (ajaxContent) {
          dispalyToastr("warning",ajaxContent.responseText);
            // console.log(ajaxContent.responseText);
        },
    });
};


// Khai báo hàm sửa thông tin course
function editCourse(paramInputEditCourseModal) {
    var vCourseIndex = getIndexFromCourseId(gCourseId);
    gCoursesDB.splice(vCourseIndex, 1, paramInputEditCourseModal) ;
    console.log("%c Edit Course Index: " + vCourseIndex, "color: yellow");
};

// Nút xóa
// Khai báo hàm lấy course id để gắn vào biến global
function getDeleteCourseId(paramDeleteButton) {
    var vTableRow = $(paramDeleteButton).parents("tr");
    var vDeleteRowData = gCOURSE_DATA_TABLE.row(vTableRow).data();
    gCourseCode = vDeleteRowData.courseCode; // Gán giá trị vào biến toàn cục

    //lọc để lấy _id nếu trùng courseCode
    gCoursesDB.filter((data) => {
        if(data.courseCode.toUpperCase() === gCourseCode.toUpperCase()) {
          gCourseId = data._id;
          console.log("%c Delete Course ID: " + gCourseId, "color:red");
          return gCourseId;
        };
    });
};

// Khai báo hàm gọi API xóa khóa học
function requesToApiDeleteCourse() {
  $.ajax({
        url: "/courses/" + gCourseId,
        type: "DELETE",
        dataType: "json",
        success: function (responseObj) {
            
          dispalyToastr("success",`Deleta course with Id:${gCourseId} successfully!`);
        },
        error: function (ajaxContent) {
          
            console.log(ajaxContent.responseText);
        },
    });
};

// Khai báo hàm xóa khóa học cho nút confirm (trong modal)
function deleteCourse(paramCourseId) {
    var vCourseIndex = getIndexFromCourseId(paramCourseId);
    gCoursesDB.splice(vCourseIndex, 1);
};



// Khai báo hàm get index dùng chung cho các nút sửa, xóa
function getIndexFromCourseId(paramCourseId) {
    var vCourseIndex = -1;
    var vCourseFound = false;
    var vLoopIndex = 0;
    while (!vCourseFound && vLoopIndex < gCoursesDB.length) {
      if (gCoursesDB[vLoopIndex]._id === paramCourseId) {
        vCourseIndex = vLoopIndex;
        vCourseFound = true;
      }
      else {
        vLoopIndex ++;
      }
    }
    return vCourseIndex;
};



</script>
</html>